hdu 4198 优先队列

E - E
Time Limit: 1000 MS      Memory Limit: 32768 KB      64bit IO Format: %I64d & %I64u

Description

Captain Clearbeard decided to go to the harbour for a few days so his crew could inspect and repair the ship. Now, a few days later, 
the pirates are getting landsick(Pirates get landsick when they don't get enough of the ships' rocking motion. That's why pirates often
 try to simulate that motion by drinking rum.). Before all of the pirates become too sick to row the boat out of the harbour, captain Clearbeard decided to leave the harbour as quickly as possible. 
Unfortunately the harbour isn't just a straight path to open sea. To protect the city from evil pirates, the entrance of the harbour is a 
kind of maze with drawbridges in it. Every bridge takes some time to open, so it could be faster to take a detour. Your task is to help captain Clearbeard and the fastest way out to open sea. 
The pirates will row as fast as one minute per grid cell on the map. The ship can move only horizontally or vertically on the map. 
Making a 90 degree turn does not take any extra time.

Input

The first line of the input contains a single number: the number of test cases to follow. Each test case has the following format: 
1. One line with three integers, h, w (3 <= h;w <= 500), and d (0 <= d <= 50), the height and width of the map and the delay for 
opening a bridge. 
2.h lines with w characters: the description of the map. The map is described using the following characters: 
―"S", the starting position of the ship. 
―".", water. 
―"#", land. 
―"@", a drawbridge. 
Each harbour is completely surrounded with land, with exception of the single entrance. 

Output

For every test case in the input, the output should contain one integer on a single line: the travelling time of the fastest route to 
open sea. There is always a route to open sea. Note that the open sea is not shown on the map, so you need to move outside of the
 map to reach open sea.

Sample Input

       
       
2
6 5 7
#####
#@#.#
#S..#
#...#
4 5 3
#@### #.### #####
###@#
#S#.#
#@..#

Sample Output

       
       
16
11

题意:

海盗要脱离大陆,去海边,有@是桥,.        '.'是可以走的路  , #是墙。问最短多少秒可以到。 对于@时需要多花费d时间

思路:

测试的时候发现是个最优解,自然去往bfs想,然而想了半天突然发现有时间的比较。自然想到优先队列,只要想到优先队列,其余的就

比较简单了和普通BFS一样

ac代码:

#include<stdio.h> #include<string.h> #include<queue> using namespace std; char map[501][501]; int book[501][501]; int h,w,d; int bx,by; int go[4][2]={0,1,1,0,0,-1,-1,0}; struct node {  int x;    int y;    int step;    friend bool operator <(node a,node b)    {   return a.step>b.step;//?????;?????;     } }; int bfs(int x,int y) {     priority_queue<node>Q;       while(!Q.empty())         Q.pop();       book[x][y]=1;         node p,q;         q.x=x;         q.y=y;         q.step=0;         Q.push(q);         while(!Q.empty())         {    p=Q.top();//???;               Q.pop();              for(int i=0;i<4;i++)              {   q=p;                  q.x+=go[i][0];                  q.y+=go[i][1];                  q.step++;                  if(book[q.x][q.y]==1||map[q.x][q.y]=='#')  continue; if(map[q.x][q.y]=='@')  q.step+=d;                  if(q.x<0||q.x>=h||q.y<0||q.y>=w)   return q.step;  if(map[q.x][q.y]=='.'||map[q.x][q.y]=='@') {                    book[q.x][q.y]=1;           Q.push(q);    }  }               } return -1; } int main() {    int t,i,j;     scanf("%d",&t);      while(t--)      {       memset(book,0,sizeof(book));    memset(map,0,sizeof(map)); scanf("%d %d %d",&h,&w,&d);          for(i=0;i<h;i++)           {  scanf("%s",map[i]);              for(j=0;j<w;j++)               {   if(map[i][j]=='S')                     {   bx=i;   by=j;    }  }  }  //printf("%d %d",bx,by);   int flag=bfs(bx,by);   printf("%d\n",flag);   } return 0; }


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

Marcus-Bao

万水千山总是情,只给五角行不行

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值